#ifndef CODEGENER_SECURE_CHANNEL_T_H
#define CODEGENER_SECURE_CHANNEL_T_H

#include "enclave.h"

#include "secure_channel_args.h"
#include "status.h"
#include "gp.h"
#include "gp_ocall.h"

#ifdef __cplusplus
extern "C" {
#endif

/**** Trusted function prototypes. ****/
int get_enclave_pubkey(size_t* session_id, uint8_t* pubkey, size_t* pubkey_len);

int init_session(size_t* session_id);

int set_enc_key(size_t session_id, uint8_t* data, size_t data_len);

int get_enclave_exch_param_len(size_t session_id, size_t* exch_param_len);

int get_enclave_exch_param(size_t session_id, uint8_t* exch_param, size_t exch_param_len);

int set_peer_exch_param(size_t session_id, uint8_t* data, size_t data_len);

void del_enclave_sec_chl(size_t session_id);

int enclave_start_sec_chl(void);

void enclave_stop_sec_chl(void);

void enclave_check_session_timeout(void);
/**** There is no untrusted function ****/

#ifdef __cplusplus
}
#endif

#endif
