#ifndef CODEGENER_SECURE_CHANNEL_U_H
#define CODEGENER_SECURE_CHANNEL_U_H

#include "secure_channel_args.h"
#include "enclave_internal.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef TEE_SECE_AGENT_ID
#define TEE_SECE_AGENT_ID 0x53656345
#endif

/**** Trusted function prototypes. ****/
cc_enclave_result_t get_enclave_pubkey(
    cc_enclave_t *enclave,
    int* retval,
    size_t* session_id,
    uint8_t* pubkey,
    size_t* pubkey_len);

cc_enclave_result_t init_session(
    cc_enclave_t *enclave,
    int* retval,
    size_t* session_id);

cc_enclave_result_t set_enc_key(
    cc_enclave_t *enclave,
    int* retval,
    size_t session_id,
    uint8_t* data,
    size_t data_len);

cc_enclave_result_t get_enclave_exch_param_len(
    cc_enclave_t *enclave,
    int* retval,
    size_t session_id,
    size_t* exch_param_len);

cc_enclave_result_t get_enclave_exch_param(
    cc_enclave_t *enclave,
    int* retval,
    size_t session_id,
    uint8_t* exch_param,
    size_t exch_param_len);

cc_enclave_result_t set_peer_exch_param(
    cc_enclave_t *enclave,
    int* retval,
    size_t session_id,
    uint8_t* data,
    size_t data_len);

cc_enclave_result_t del_enclave_sec_chl(
    cc_enclave_t *enclave,
    size_t session_id);

cc_enclave_result_t enclave_start_sec_chl(
    cc_enclave_t *enclave,
    int* retval);

cc_enclave_result_t enclave_stop_sec_chl(
    cc_enclave_t *enclave);

cc_enclave_result_t enclave_check_session_timeout(
    cc_enclave_t *enclave);

;
/**** There is no untrusted function ****/

#ifdef __cplusplus
}
#endif

#endif
